

bl_info = {
    "name": "IMDJS_draw_mesher",
    "author": "imdjs",
    "version": (0, 2,0),
    "blender": (2, 80,0),
    "location":"View3D > Right panl >Tools >draw_mesher",
    "description":"Generate mesh or curve from drawing",
    "wiki_url": "---"
                "---",
    "tracker_url": "---"
                   "",
    "category": "Add Mesh"}
    #category": All  User  Enabled  Disabled  3D View  Add  Add Curve  Add Mesh  Animation  Compositing  Development  Game Engine  Import-Export  Material  Mesh  Node  Nodes  Object  Outliner  Paint  Particle  Render  Rigging  Scene  Sculpting  Sequencer  Surface  System  Text Editor  UI  UV  User Interface  Listener
    
from .draw_OP import *


#///////////////////////////////////////////
class 卐draw_mesher卐Panel(bpy.types.Panel):
    bl_label = "draw_mesher"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Tools'
    # bl_context = "mesh_edit"
    bl_options = {"DEFAULT_CLOSED"}
        
    # @classmethod 
    # def poll(self,context):
        # return  context.active_gpencil_layer;
    
    def draw(self, context):        
        layout = self.layout;
        layout.label(text=语.按G);
        layout.label(text=语.按W);
        layout.label(text=语.按ESC);
        uil行=layout.row(align=False);ppDrawMesherS=context.scene.ppDrawMesherS;LG.oA=context.active_object;
        # uil行.prop(data=ppDrawMesherS,property='fp精简角度',text='angle',translate=True,icon='NONE');
        
        uil行2 = layout.row(align=True);#第二行
        uil行2.prop_enum(ppDrawMesherS,  "ep模式", value="ROT", text=语.旋转,translate=True, icon="CONE");
        uil行2.prop_enum(ppDrawMesherS,  "ep模式", value="LOFT", text=语.放样, translate=True, icon="CUBE");
        # uil列=layout.column(align=False);
        uil行2.scale_y=1.3; 
        
        if(LG.oA and LG.oA.ppDrawMesherO.bp已经生成o):#LG.oA and "draw_mesher"in
            ppDrawMesherO=LG.oA.ppDrawMesherO;
            uil行=layout.row(align=False);
            # uil行.prop(ppDrawMesherS,"ip乚数");
            uil行.prop(ppDrawMesherO,"ip每节曲点o");
            
            uil行=layout.row(align=False); 
            uil行.prop(ppDrawMesherO,"ip几个截面o");     
            uil行.prop(ppDrawMesherO,"ip几轴o");   
            
            uil行=layout.row(align=False);            
            uil行.prop(ppDrawMesherO,"bp没有曲点o",toggle=True); 
            uil行.prop(ppDrawMesherO,"bp平滑o",toggle=True);        
            
            layout.operator(卐进入编辑模式dr卐Operator.bl_idname,translate=True, icon = "EDITMODE_HLT"); 
            
            uil行=layout.row().split(factor=0.8,align=False);
            uil行.operator(卐进入画模式dr卐Operator.bl_idname,translate=True, icon = "OUTLINER_DATA_CURVE");
            uil行.operator(卐关于我drmesher卐Operator.bl_idname,translate=True, icon = "QUESTION");
        else:
            uil行=layout.row(align=False);
            # uil行.prop(ppDrawMesherS,"ip乚数");
            uil行.prop(ppDrawMesherS,"ip每节曲段数");
            
            uil行=layout.row(align=False);
            # uil行.prop(ppDrawMesherS,"ip画平面大小");        
            uil行.prop(ppDrawMesherS,"ip几个截面");     
            uil行.prop(ppDrawMesherS,"ip几轴");
            
            uil行=layout.row(align=False);
            #uil行.prop(ppDrawMesherS,"bp只生成网点",toggle=True);    
            uil行.prop(ppDrawMesherS,"bp没有曲点",toggle=True);  
            uil行.prop(ppDrawMesherS,"bp平滑",toggle=True);        
            
            uil行=layout.row().split(factor=0.8,align=False);
            uil行.operator(卐进入画模式dr卐Operator.bl_idname,translate=True, icon = "OUTLINER_DATA_CURVE");
            uil行.operator(卐关于我drmesher卐Operator.bl_idname,translate=True, icon = "QUESTION");
        
        # layout.operator(卐卸载DLLGPencil卐Operator.bl_idname,translate=True, icon = "CANCEL");
        
        #------------------------------
        """
        uil行=layout.row(align=False);
        uil行.prop(data=ppDrawMesherS,property='bp是保留线段',text='keep lines',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);   
        uil行.prop(data=ppDrawMesherS,property='bp是保留GP',text='keep GP',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);          
        uil行.prop(data=ppDrawMesherS,property='bp不切割',text='dont cut',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0); 
        """
        # layout.operator(卐GP生成线段卐Operator.bl_idname,translate=True, icon = "OUTLINER_DATA_CURVE");
        
#========================================
class 卐draw_mesher卐AddonPreferences(bpy.types.AddonPreferences):
    bl_idname =__name__ #●●必须用__name__ "pref.greenland";
    #ip图标高宽:IntProperty(name='size of icon',description='',default=128,min=32,max=512,step=1);
    # sp自定义库路径:StringProperty(name='custom library path',description='the custom library path',default='',maxlen=0,subtype='FILE_PATH',update=None);
    ep语言:EnumProperty( name="language", description="language settign", items=[("汉","汉","chinese"),("english","english","--")],default="english",update= None);    
    def draw(self, context):
        uil界 = self.layout;
        #uil界.prop(self, "ip图标高宽");
        #uil界.separator()
        #uil界.prop(data=self,property='sp自定义库路径');#■■暂时无效
        uil行=uil界.row();
        uil栋=uil行.column();
        # uil栋.props_enum(data=context.scene.ppDrawMesherS, property="ep语言");#单行切换按钮
        uil栋.props_enum(data=self, property="ep语言");#单行切换按钮
        
#///////////////////////////////////////////
def ΔUPDATEdr(self,context):
    if(G.b已经生成__.value):
        print("ΔUPDATEdr==",);
        if(LG.b停止更新G==False):
            LG.b停止更新G=True;
            LG.dllIMDJS.iΔ重构曲线(LG.cvpC,c_void_p(LG.oA.as_pointer()),True);
            LG.dllIMDJS.Δ最终成面ξ(LG.cvpC,c_void_p(LG.oA.as_pointer()),True,byref(G.ci线点数0G),byref(G.ci线点数1G),byref(G.ci线点数2G) \
                                                                    ,byref(LG.ci点数G),byref(LG.ci边数G),byref(LG.ci面数G),byref(LG.ci环数G));
            十点线面卩(LG.oA.data,LG.ci点数G.value,LG.ci边数G.value,LG.ci面数G.value,LG.ci环数G.value);
            LG.dllIMDJS.重属性网(c_void_p(LG.oA.data.as_pointer()),True,False,False);
            LG.oA.data.update();

            LG.b停止更新G=False;
        
def ΔUPDATE平滑(self,context):
    # print("self==",self);
    oA=context.active_object;
    if(oA):
        if(oA.ppDrawMesherO.bp平滑o):
            bpy.ops.object.shade_smooth();
        else:
            bpy.ops.object.shade_flat();
#------------------------------
class 卐draw_mesher卐PropertyGroup(bpy.types.PropertyGroup):
    name:bpy.props.StringProperty();
    ip每节曲段数:IntProperty(name=语.L每节曲点数[0],description=语.L每节曲点数[1],default=8,min=3,max=100,update=ΔUPDATEdr);
    # ip乚数:IntProperty(name=语.乚数,description=语.乚数,default=8,min=3,max=50);
    ip画平面大小:IntProperty(name=语.画平面大小,description=语.画平面大小,default=10,min=5,max=50);
    ip几个截面:IntProperty(name=语.几个截面,description=语.几个截面,default=20,min=3,max=50,update=ΔUPDATEdr);
    ip几轴:IntProperty(name=语.L几轴[0],description=语.L几轴[1],default=3,min=2,max=3);
    bp只生成网点:BoolProperty(语.L只生成网点[0],description=语.L只生成网点[1],default=False);
    bp没有曲点:BoolProperty(name=语.L没有曲点[0],description=语.L没有曲点[1],default=False);
    bp锁Y轴:BoolProperty(name=语.锁Y轴,description=语.锁Y轴,default=True);#画第二个面时锁定平面
    bp封顶:BoolProperty(name=语.L封顶[0],description=语.L封顶[1],default=False);
    bp封底:BoolProperty(name=语.L封底[0],description=语.L封底[1],default=False);
    bp平滑:BoolProperty(name=语.L平滑[0],description=语.L平滑[1],default=False);    
    ep模式:EnumProperty( name=语.模式, description=语.模式,items=  [("ROT","rotation","---","CONE",0),("LOFT", "loft","---.","CUBE",1)  ],default="ROT");
    #------------------------------
    fp精简角度:FloatProperty(name=语.精减角,description='Decimate angle',default=170.0,min=0.0,max=180.0,step=2,precision=1,subtype='NONE',unit='NONE',update=None);
    # bp是保留线段:BoolProperty(name='keep lines',description='keep the lines which generated by GPencil',default=False,subtype='NONE',update=None);
    # bp是保留GP:BoolProperty(name='keep GPencils',description='keep the GPencils after drawing',default=False,subtype='NONE',update=None);
    # bp不切割:BoolProperty(name='dont cut',description='dont cut the active object',default=False,subtype='NONE',update=None);
    ep语言:EnumProperty( name="language", description="language settign", items=[("汉","汉","chinese",0),("english","english","--",1)],default="english",update= None);

# def ΔUPDATE编辑模式(self,context):
class 卐DM_object卐PropertyGroup(bpy.types.PropertyGroup):
    name:bpy.props.StringProperty();
    bp已经生成o:BoolProperty(name=语.L编辑[0],description=语.L编辑[1],default=False,subtype='NONE');
    ip每节曲点o:IntProperty(name=语.L每节曲点数[0],description=语.L每节曲点数[1],default=8,min=3,max=100,update=ΔUPDATEdr);
    ip几个截面o:IntProperty(name=语.几个截面,description=语.几个截面,default=20,min=3,max=50,update=ΔUPDATEdr);
    ip几轴o:IntProperty(name=语.L几轴[0],description=语.L几轴[1],default=3,min=2,max=3);
    bp只生成网点o:BoolProperty(name=语.L只生成网点[0],description=语.L只生成网点[1],default=False);
    bp没有曲点o:BoolProperty(name=语.L没有曲点[0],description=语.L没有曲点[1],default=False);
    bp顶界线在y正o:BoolProperty(default=False);
    bp锁Y轴o:BoolProperty(name=语.锁Y轴,description=语.锁Y轴,default=True);#画第二个面时锁定平面
    bp封顶o:BoolProperty(name=语.L封顶[0],description=语.L封顶[1],default=False);
    bp封底o:BoolProperty(name=语.L封底[0],description=语.L封底[1],default=False);
    bp平滑o:BoolProperty(name=语.L平滑[0],description=语.L平滑[1],default=False,update=ΔUPDATE平滑); 
    ep模式o:EnumProperty( name=语.模式, description=语.模式,items=  [("ROT","rotation","---","CONE",0),("LOFT", "loft","---.","CUBE",1)  ],default="ROT");
    fp精简角度o:FloatProperty(name=语.精减角,description='Decimate angle',default=170.0,min=0.0,max=180.0,step=2,precision=1,subtype='NONE',unit='NONE',update=None);
    
def register():
    注册类([(卐关于我drmesher卐Operator,卐draw_mesher卐PropertyGroup,卐DM_object卐PropertyGroup,卐卸载DLLGPencil卐Operator,卐进入编辑模式dr卐Operator,卐进入画模式dr卐Operator,卐GP生成线段卐Operator,卐draw_mesher卐Operator,卐draw_mesher卐Panel,卐画draw_mesher卐Operator,卐draw_mesher卐AddonPreferences)],False);
    # bpy.utils.register_module(__name__);
    bpy.types.Scene.ppDrawMesherS=PointerProperty(type=卐draw_mesher卐PropertyGroup);
    bpy.types.Object.ppDrawMesherO=PointerProperty(type=卐DM_object卐PropertyGroup);
    
    
Ls模块=[文件夹此DRmesh+".draw_OP",文件夹此DRmesh+".draw",文件夹此DRmesh+".global_var",文件夹此DRmesh+".LANG",];#文件夹此DRmesh
def unregister():
    bpy.ops.dele.gpencil_tool();
    #print("sys.modules==",sys.modules.keys());
    del bpy.types.Scene.ppDrawMesherS;
    del bpy.types.Object.ppDrawMesherO;

    注销类([(卐关于我drmesher卐Operator,卐draw_mesher卐PropertyGroup,卐DM_object卐PropertyGroup,卐卸载DLLGPencil卐Operator,卐进入编辑模式dr卐Operator,卐进入画模式dr卐Operator,卐GP生成线段卐Operator,卐draw_mesher卐Operator,卐draw_mesher卐Panel,卐画draw_mesher卐Operator,卐draw_mesher卐AddonPreferences)],False);
    删除模块(Ls模块名=Ls模块+Ls模块selfG+Ls模块G);
        
if (__name__ == "__main__"):
    register()

    